import torch
import os
import numpy as np
import torch
import torch
import numpy as np
import torch.nn.functional as F
from sentence_transformers import SentenceTransformer

def getDataset(data_size,trajectory_dir,env,train_tasks=[]):
    encoded_empty_language=torch.tensor(SentenceTransformer("sentence-transformers/paraphrase-TinyBERT-L6-v2").encode("")).unsqueeze(dim=0).to(device='cuda')
    states, traj_lens, returns,languages = [], [], [],[]
    dataset=[]
    print(env)
    print(trajectory_dir)
    for i in range(data_size):
            file=f"{trajectory_dir}/trajectory_{i+1}.pth"
            if os.path.exists(file):
                data=torch.load(file)
                states.append(data["state"])
                traj_lens.append(len(data["state"]))
                returns.append(data["return_to_go"][0])
                languages.append(data["languages"])
                dataset.append(data)

    print("=" * 50)
    print(f"Starting new experiment")
    print(f"Average return: {np.mean(returns):.2f}, std: {np.std(returns):.2f}")
    print(f"Max return: {np.max(returns):.2f}, min: {np.min(returns):.2f}")
    print("=" * 50)
    print("dataset trajectories: ",len(dataset))
    return dataset[0:data_size]


if __name__ == "__main__":
   getDataset(2000,"./metaworld")
    